subroutine debugpotential
  use variables
  use constants
  use debug_variables
  double precision :: strmat_store(3,3),hmat_store(3,3)
  double precision,allocatable :: rx_store(:),ry_store(:),rz_store(:)
  allocate (rx_store(n),ry_store(n),rz_store(n))
  
  ! For debugging force calculation
  !
  if (.true.) then
     do i=1,n
        rx(i)=rx(i)+vx(i)*1.d-14
        ry(i)=ry(i)+vy(i)*1.d-14
        rz(i)=rz(i)+vz(i)*1.d-14
     enddo
  endif
  if (.false.) then
     dx=0.0001
     hmat_store=hmat; rx_store=rx; ry_store=ry; rz_store=rz
     call potential; print *,'E_tot=',real(enpot/ev/n)
     drho=debug_val(2)
     
     hmat=hmat_store; rx=rx_store; ry=ry_store; rz=rz_store
     strmat_set = 0.0d0;strmat_set(1,1)=dx
     call strain; call potential; print *,'E_tot=',real(enpot/ev/n)
     rho2=debug_val(1)
     
     hmat=hmat_store; rx=rx_store; ry=ry_store; rz=rz_store
     strmat_set = 0.0d0;strmat_set(1,1)=-dx
     call strain; call potential; print *,'E_tot=',real(enpot/ev/n)
     rho1=debug_val(1)
     
     xx=(rho2-rho1)/(dx*2.0)
     print *,(rho1),(rho2),real(dx*2.0)
     print *,'calculation = ',real(drho),' correct value = ',real(xx)
     stop
  endif
  if (.false.) then
     open (50,FILE='hoge.d')
     do i=-10,10
        hmat=hmat_store; rx=rx_store; ry=ry_store; rz=rz_store
        strmat_set = 0.0d0;strmat_set(1,1)=dx*i
        call strain; call potential
        rhon=debug_val(1)
        print *,i,rhon
        write (50,*) i,rhon
     enddo
     close (50)
     stop
  endif
  if (.true.) then
     imv=1
     rx(imv)=rx(imv)+a/100.0
     dx=1.0d-16;rx0=rx(imv)
     call potential; print *,'E_tot=',real(enpot/ev/n)
     drho=debug_val(2)
     
     rx(imv)=rx0+dx
     call potential; print *,'E_tot=',real(enpot/ev/n)
     rho1=debug_val(1)
     rx(imv)=rx0-dx
     call potential; print *,'E_tot=',real(enpot/ev/n)
     rho2=debug_val(1)
     xx=(rho1-rho2)/(dx*2.0)
     print *,(rho1),(rho2),real(dx*2.0)
     print *,'calculation = ',real(drho),' correct value = ',real(xx)
     stop
  endif
  if (.false.) then
     open (50,FILE='hoge.d')
     do i=-10,10
        rx(imv)=rx0+dx*dble(i)
        call potential
        rhon=debug_val(1)
        xx=(rhon-rhop)/dx
        print *,rx(imv),rhon
        write (50,*) rx(imv),rhon
     enddo
     close (50)
     stop
  endif

  
end subroutine debugpotential
